#include "nucleon.h"
#include <iostream>

using namespace std;
using namespace GraphicsLib;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

Nucleon::Nucleon(Point3 pos, Vector dir,Colour c)
{
// set the particles position on direction
Pos=pos;
Dir=dir;
colour=c;
//Orient=orient;
}

//------------------------------------------------------------------------------

Nucleon::~Nucleon()
{
// nothing to do here
}

//------------------------------------------------------------------------------

void Nucleon::Draw(GLfloat lod)
{
glPushMatrix();
	lod = 4-lod/50;
	Pos.Translate();
	//colour.set(lod,lod,lod);
	colour.Use();
 	glutSolidSphere(0.075,5,5);
	/*if(lod+1>2)
	{
	glutSolidSphere(0.075,(int) lod+1,(int) lod+1);
	}*/
glPopMatrix();
}

/*pulsation of the atom is determined by the kinetic energy level of the atom, the greater the
energy level the faster the pulsation, and to a maximum point the greater the distortion of
the atom.*/

void Nucleon::Pulsate(Point3 centre)
{
	float X = Pos.x-centre.x;
	float Y = Pos.y-centre.y;
	float Z = Pos.z-centre.z;


	float pulse = glutGet(GLUT_ELAPSED_TIME);
	if (Pulse+100<glutGet(GLUT_ELAPSED_TIME))
	{

	//1+sin(pulse)		((1 + sin(pulse))/2)+1;
	float zScale = sin(pulse*100)*0.075;

	//cout<<zScale<<endl;

	Z = Z + zScale;
	//Pulse = sin(pulse);
	Pulse = glutGet(GLUT_ELAPSED_TIME);
	//Pos.x = X + centre.x;
	//Pos.y = Y + centre.y;
	//Pos.z = Z + centre.z;
	Pulse = glutGet(GLUT_ELAPSED_TIME);
	}
}

//------------------------------------------------------------------------------

void Nucleon::UpdateA(Point3 centre,Vector dir)
{
	float theta = 0.005;

	float X = Pos.x-centre.x;
	float Y = Pos.y-centre.y;


	float tempX = X * cos(theta) - Y * sin(theta);
	float tempY = X * sin(theta) + Y * cos(theta);

	Pos.x = centre.x + tempX;
	Pos.y = centre.y + tempY;

	//Pos+=dir;

}

//------------------------------------------------------------------------------

void Nucleon::UpdateB()
{
	Pos+=Dir;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
