#include "atom.h"
#include "nucleon.h"

using namespace GraphicsLib;
using namespace std;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

atom::atom(Point3 pos, Vector dir, int atomicnumber, int atomicmass, int u235 )
{
	Pos=pos;
	Dir=dir;
	AtomicNumber=atomicnumber;
	AtomicMass=atomicmass;
	keAtom=RNG::uniform();
	U235=u235;
}

//------------------------------------------------------------------------------

atom::~atom()
{
// nothing to do here
}

//------------------------------------------------------------------------------

void atom::Update()
{
Pos+=Dir;
}


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
