#ifndef _ATOM_H_
#define _ATOM_H_
#include <vector>
#include "GraphicsLib.h"
#include "nucleon.h"
#include <GL/gl.h>
#include <GL/glut.h>

using namespace std;

class atom
{
public :
	// Position of the Atom
	GraphicsLib::Point3 Pos;
	//Direction of the Atom
	GraphicsLib::Vector Dir;
	//total number of nucleons within the atom
	int AtomicMass;
	//number of protons within the mass of the atom
	int AtomicNumber;
	//kinetic energy of atom
	float keAtom;
	float U235;
	// Constructor
	atom(GraphicsLib::Point3 pos, GraphicsLib::Vector dir, int atomicmass, int atomicnumber, int u235);
	// destructor
	~atom();
	// method to draw the particle
	//void Draw();
	// methods to update the particle
	void Update();
};

#endif
