#ifndef _NUCLEON_H_
#define _NUCLEON_H_
#include "GraphicsLib.h"
#include <GL/gl.h>
#include <GL/glut.h>


class Nucleon
{
public :
	// Position of the Nucleon
	GraphicsLib::Point3 Pos;
	//Direction of the Nucleon
	GraphicsLib::Vector Dir;
	// Colour of the Nucleon
	GraphicsLib::Colour colour;

	float	Pulse; 
	// Orientaion of Nucleon
	//GraphicsLib::Vector Orient;
	// Constructor
	Nucleon(GraphicsLib::Point3 pos, GraphicsLib::Vector dir,GraphicsLib::Colour c);
	// destructor
	~Nucleon();
	// method to draw the particle
	void Draw(GLfloat lod);
	//pulsation of atoms
	void Pulsate(GraphicsLib::Point3 centre);
	// methods to update the particle
	void UpdateA(GraphicsLib::Point3 centre, GraphicsLib::Vector dir);
	void UpdateB();
};
#endif
