#ifndef _SHELLBOX_H
#define _SHELLBOX_H
#include "GraphicsLib.h"

using namespace std;

class shellBox
{
public :
	//width of the bounding box
	float Width;
	//height of the bounding box
	float Height;
	//depth of the bounding box
	float Depth;
	//centre point for the bounding box
	GraphicsLib::Point3 BOXCentre;
	//corner points of the
	GraphicsLib::Point3 shellCorners[8];
	//normals for faces
	GraphicsLib::Vector shellNormals[6];
	//constructor of the bounding box
	shellBox(float width,float height,float depth,GraphicsLib::Point3 boxCentre);
	//destructor for shellBox
	~shellBox();
	void set(float width,float height,float depth,GraphicsLib::Point3 boxCentre);
	//draw method for the bounding box
	void shellBox::Draw(void);
};
#endif
